#include <Servo.h>
#include <IRremote.h>

int RECV_PIN = 12;
IRrecv irrecv(RECV_PIN);
decode_results results;
Servo myservo;
// modul ultrasonic ECHO la A0
int Echo_Pin=A0;  
// modul ultrasonic TRIG la A1
int Trig_Pin=A1;  
int i = 0;
int counter = 0;

//pini care controleaza viteaza---- ENA 
#define Lpwm_pin  5     
#define Rpwm_pin  6
#define IR_Stop    0x00ff02fd

// pini care controleaza directia de intoarcere a misinii
// IN1
int pinLB=2;
// IN2
int pinLF=4;
// IN3
int pinRB=7;
// IN4
int pinRF=8;

// variabile care verifică distanța până la un anumit obstacol
volatile int D_mix;
volatile int D_mid;
volatile int D_max;
volatile int Front_Distance;
volatile int Left_Distance;
volatile int Right_Distance;
volatile int Right_IR_Value;
volatile int Left_IR_Value;


// verificarea distanței până la un anumit obstacol
float checkdistance() {
  digitalWrite(Trig_Pin, LOW);
  delayMicroseconds(2);
  digitalWrite(Trig_Pin, HIGH);
  delayMicroseconds(10);
  digitalWrite(Trig_Pin, LOW);
  float distance = pulseIn(Echo_Pin, HIGH) / 58.00;
  delay(10);
  return distance;
}


// se verifică distanța laterală pentru a putea vedea pe unde își continuă drumul
void Detect_Left_and_Right__distance() {

  // verificare distanță în stânga
  myservo.write(180);
  delay(400);
  // distanța în stânga
  Left_Distance = checkdistance();
  delay(600);
  Serial.print("Distanța Stânga:");
  Serial.println(Left_Distance);
  
  // verificare distanță în dreapta
  myservo.write(0);
  delay(400);
  // dostanța în dreapta
  Right_Distance = checkdistance();
  delay(600);
  Serial.print("Distanța Dreapta:");
  Serial.println(Right_Distance);

  // continuare drum înainte
  myservo.write(90);
}

void Ultrasonic_obstacle_avoidance()
{
  // valoare returnată de funcția de aflare a distanței
  Front_Distance = checkdistance();

  // dacă distanța esgte una validă și mică până în obstacol
  // se schimbă direcția de mers
  // în funcție de direcția în care există mai mult spațiu 
  // disponibil
  if((Front_Distance < 20) && (Front_Distance > 0))
{
    stopp(); //stop
    delay(100);

    // veirifcă distanțele
    myservo.write(180);
    delay(500);
    Left_Distance=checkdistance();
    delay(100);
    myservo.write(0);
    delay(500);
    Right_Distance=checkdistance();
    delay(100);

    // dacă este mai mult spațiu disponibil în partea stângă
    if(Left_Distance > Right_Distance) {
      // își continuă drumul la stânga
      rotate_left(150);
      myservo.write(90);
      delay(300); 
    }
    // dacă este mai mult spațiu disponibil în partea dreaptă
    else 
    {
       //își continuă drumul la dreapta
      rotate_right(150);
      myservo.write(90);
      delay(300); 
    }
  }
  else  // nu este întâlnit niciun obstacol
  {
    // își continuă drumul înainte
    go_forward(100);
    counter ++;
  }

  if(counter == 5) {
    stopp();
  }

  // melodie pentru mașina de poliție
  tone(3,650,750);
  tone(3,900,1000);
  tone(3,650,750);
  tone(3,900,1000);
}


void Obstacle_Avoidance_Main() 
{
  Ultrasonic_obstacle_avoidance();
}

// pentru a comanda mașina și a o opri cu ajutorul unei telecomande
void IR_Control(void)
{
   unsigned long Key;
   if(irrecv.decode(&results))    
 {
     Key = results.value;
    switch(Key)
     {
       case IR_Stop:stopp();
       break;
       default: 
       break;      
     } 
     irrecv.resume();
    } 
  
}

// pentru IR
void setup(){
  irrecv.enableIRIn();
  myservo.attach(A2);
  Serial.begin(9600);
  D_mix = 10;
  D_mid = 20;
  D_max = 100;
  Front_Distance = 0;
  Left_Distance = 0;
  Right_Distance = 0;
  myservo.write(90);
  pinMode(Echo_Pin, INPUT);      
  pinMode(Trig_Pin, OUTPUT);    
  pinMode(pinLB,OUTPUT); // /pin 2
  pinMode(pinLF,OUTPUT); // pin 4
  pinMode(pinRB,OUTPUT); // pin 7
  pinMode(pinRF,OUTPUT);  // pin 8
  pinMode(Lpwm_pin,OUTPUT);  // pin 5 (PWM) 
  pinMode(Rpwm_pin,OUTPUT);  // pin 6(PWM) 
 
}

void loop(){
  Obstacle_Avoidance_Main();
}

// pentru deplasarea înainte a mașinii
void go_forward(unsigned char speed_val)  {
     digitalWrite(pinRB,HIGH); 
     digitalWrite(pinRF,LOW);
     digitalWrite(pinLB,HIGH);
     digitalWrite(pinLF,LOW);
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val); 
    }

// pentru a vira la stânga   
void rotate_left(unsigned char speed_val) {
     digitalWrite(pinRB,HIGH);
     digitalWrite(pinRF,LOW );  
     digitalWrite(pinLB,LOW); 
     digitalWrite(pinLF,HIGH);
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val); 
    }
// pentru a vira la dreapta
void rotate_right(unsigned char speed_val) 
    {
      digitalWrite(pinRB,LOW);  
     digitalWrite(pinRF,HIGH);
     digitalWrite(pinLB,HIGH);
     digitalWrite(pinLF,LOW);  
     analogWrite(Lpwm_pin,speed_val);
     analogWrite(Rpwm_pin,speed_val);
     
    }    
// pentru a opri mașina cu IR
void stopp()
    {
     digitalWrite(pinRB,HIGH);
     digitalWrite(pinRF,HIGH);
     digitalWrite(pinLB,HIGH);
     digitalWrite(pinLF,HIGH);
    }
